package example;

import java.util.Locale;
import java.util.ResourceBundle;

import labir.utils.FileUtil;
import labir.utils.IconCache;
import labir.utils.JSONUtil;
import labir.utils.MenuCreater;
import labir.utils.interfaces.IMenuBar;

import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.graphics.Image;

import net.sf.json.JSONObject;

public class MenuCreaterTest implements IMenuBar
{
	private          JSONObject jsonMenu;
	private  static  IconCache  iconCache;
	private  final   String[]   IMAGES     = {"cut.gif"  ,
                                              "copy.gif" ,
                                              "paste.gif",
                                              "print.gif",
                                              "shell.gif",
                                             };
	private  Locale locale = new Locale("ru");
 	private  ResourceBundle  resource = ResourceBundle.getBundle("resources/menu", locale);
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 	/**
 	 * Конструктор класса
 	 * @param shell основное окно приложения
 	 */
	public MenuCreaterTest(final Shell shell)
	{
		// Кэш изображений
		iconCache = new IconCache();
		iconCache.setImagesDir("/images/");
		// Загрузка изображений
		iconCache.loadImages (shell.getDisplay(), IMAGES);
		// Установка иконки приложения
		shell.setImage(iconCache.getImage(IMAGES.length - 1));
		
		String contentMenu = FileUtil.loadResourceFileContent("/resources/menu.json");
		jsonMenu = JSONUtil.createJSONObject(contentMenu);
		(new MenuCreater(shell, this)).createMenu(resource, jsonMenu);
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	/**
	 * Процедура обработки выделений пункта меню
	 * @param menuName пункт меню
	 *  @see IMenuBar
	 */
	@Override
	public void selectMenuItem(String menuName)
	{
		System.out.println ("SWTMenuTest.selectMenuItem() : menuName = " + menuName);
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	@Override
	public void showSubmenus(String menuName)
	{
//		System.out.println ("SWTMenuTest.showSubmenus() : menuName = " + menuName);
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	@Override
	public void hideSubmenus(String menuName)
	{
//		System.out.println ("SWTMenuTest.hideSubmenus() : menuName = " + menuName);
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	@Override
	public Image getImage(String imageName)
	{
		Image image = null;
		for (int i = 0; i < IMAGES.length; i++) {
			if (IMAGES[i].equalsIgnoreCase(imageName)) {
				image = iconCache.getImage(i);
				break;
			}
		}
		return image;
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	public static void main (String [] args)
	{
		Display display = new Display();
		Shell   shell   = new Shell (display);
		shell.setText("SWT пример использования Menu");
	
		shell.setSize(400, 200);
		new MenuCreaterTest(shell);
	
		shell.open ();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch ())
				display.sleep ();
		}
		iconCache.freeResources();
		display.dispose ();
	}
}
